      subroutine psode(neqn,nm,np,f,evalj,t,y,tend,tol,h,k,cor,
     +                 a,c,d,avec,dyn,fjm1,v,aux,
     +                 ipvt,yj,yjm1,yjl,rjac,rjlu,solmax,
     +                 ijac,mljac,mujac)
      implicit double precision(a-h,o-z)
      dimension y(neqn),a(nm,*),c(nm),fjm1(np,*),yj(np,*),yjm1(np,*),
     +          yjl(np,*),v(np,*),aux(neqn),ipvt(np,*),rjac(np,neqn),
     +          rjlu(np,np,4),avec(nm),dyn(neqn),d(nm)
      integer ijac,mljac,mujac
      dimension refm(5,5),bref(5),ipvref(5)
      integer ifail(4)
      external f,evalj
      integer cor,p
      logical reject,chh,freshj,badcn,reduh
      logical ovfl
      common/istat/nsteps,naccpt,nrejct,njac,nlu,nlus,nfe,nfes,nfb,nfbs
      logical banded
c-----------------------------------------------------
c   smallest number satisfying 1.0 + uround > 1.0
c   uround may require amendment on different machines
c-----------------------------------------------------
      double precision uround
c
c Cray
c
c     parameter (uround = 2d0**(-47))
c
c IEEE (e.g. sgi / sun)
c
      parameter (uround = 2d0**(-52))
c--------------------------
c   initialisations
c--------------------------
      banded = mljac.ne.neqn
      if (banded) mjac = mljac + mujac + 1
      b0=0.1d0
      do 300 i=1,k+1
         refm(i,1)=0.0d0
         refm(1,i)=1.0d0
  300    bref(i)=1.0d0
      bref(2)=1.0d0-b0
      do 310 i=1,k
         do 310 j=1,k
  310       refm(i+1,j+1)=c(j)**i
      call dgefa(refm,5,k+1,ipvref,if)
      call dgesl(refm,5,k+1,ipvref,bref,0)
      trsh=2.0d0*uround/tol
      itermx=15
      gamma=0.1d0
      delta=1.0d-3
      nfe=0
      nfes=0
      nfb=0
      nfbs=0
      hlast=h
      nsteps=0
      naccpt=0
      nrejct=0
      njac=0
      nlu=0
      nlus=0
      reject=.false.
      badcn=.true.
      chh=.true.
c-----------------------------
c   integration step
c-----------------------------
   20 continue
      if(h .lt. 10.0d0*uround)then
         write(6,1)t
    1    format('   the routine has advanved the solution up to t=',
     +          e16.8,/,'   and stopped because the step size has',
     +          ' become too small'/'   try a less stringent value',
     +          ' of tol or change to a higher-order method')
         return
      endif
      if(tend-t .lt. uround)return
      if(t+h .gt. tend)then
         h=tend-t
         chh=.true.
      endif
      call f(neqn,t,y,dyn)
      nfe=nfe+1
      nfes=nfes+1
   30 nsteps=nsteps+1
      freshj=.false.
      reduh=.false.
c--------------------------------
c   evaluate the jacobian matrix
c--------------------------------
   40 if(badcn)then
         call evalj(neqn,t,y,rjac,np)
         njac=njac+1
         freshj=.true.
      endif
c--------------------------------
c   decomposition of I-d*h*J
c--------------------------------
   50 if(freshj .or. chh)then
         if (banded) then
cvd$ concur
cvd$ nodepchk
            do 53 l=1,k
               do 52 j=1,neqn
                  do 51 i=1,mjac
                     rjlu(mljac+i,j,l)=-d(l)*h*rjac(i,j)
   51             continue
                  rjlu(mjac,j,l)=1d0+rjlu(mjac,j,l)
   52          continue
   53       continue
cvd$ concur
cvd$ cncall
            do 54 l=1,k
               call dgbfa(rjlu(1,1,l),np,neqn,mljac,mujac,
     +                    ipvt(1,l),ifail(l))
   54       continue
            
         else
cvd$ concur
cvd$ nodepchk
            do 71 l=1,k
               do 70 j=1,neqn
                  do 60 i=1,neqn
   60                rjlu(i,j,l)=-d(l)*h*rjac(i,j)
   70             rjlu(j,j,l)=1.0d0+rjlu(j,j,l)
   71       continue
cvd$ concur
cvd$ cncall
            do 72 l=1,k
               call dgefa(rjlu(1,1,l),np,neqn,ipvt(1,l),ifail(l))
   72       continue
         endif

         do 75 l=1,k
            if(ifail(l).ne.0)then
               write(6,2)ifail(l),t
    2          format('  error in decomposition',i5,' at t=',e12.6)
               stop
            endif
   75    continue   
         nlu=nlu+k
         nlus=nlus+1
      endif
c--------------------------
c   form the prediction
c--------------------------
      if(naccpt.eq.0)then
cvd$ concur
         do 80 l=1,k
            do 80 i=1,neqn
               yjm1(i,l)=y(i)
   80    continue
      else
cvd$ concur
cvd$ cncall
         do 90 l=1,k
            call colpol(neqn,np,yjl,yjm1,c,l,k,1.0d0+c(l)*h/hlast)
   90    continue
      endif
c-----------------------------
c   start of the iteration
c-----------------------------
      iter=0
cvd$ concur
cvd$ cncall
   95 do 100 l=1,k
         call f(neqn,t+c(l)*h,yjm1(1,l),fjm1(1,l))
  100 continue
      nfe=nfe+k
      nfes=nfes+1
cvd$ concur
      do 131 l=1,k
         if((cor/2)*2 .ne. cor)then
            do 110 i=1,neqn
  110          v(i,l)=yjm1(i,l)-y(i)-h*avec(l)*dyn(i)
         else
            do 111 i=1,neqn
  111          v(i,l)=yjm1(i,l)-y(i)
         endif
         do 130 j=1,k
            do 120 i=1,neqn
  120          v(i,l)=v(i,l)-h*a(l,j)*fjm1(i,j)
  130       continue
  131 continue
      if (banded) then
cvd$ concur
cvd$ cncall
         do 132 l=1,k
            call dgbsl(rjlu(1,1,l),np,neqn,mljac,mujac,
     +                 ipvt(1,l),v(1,l),0)
  132    continue
      else
cvd$ concur
cvd$ cncall
         do 133 l=1,k
            call dgesl(rjlu(1,1,l),np,neqn,ipvt(1,l),v(1,l),0)
  133    continue
      endif
cvd$ concur
      nfb=nfb+k
      nfbs=nfbs+1
      do 150 l=1,k
         do 140 i=1,neqn
  140       yj(i,l)=yjm1(i,l)-v(i,l)
  150    continue
      iter=iter+1
c------------------------------------
c   test on the convergence behaviour
c------------------------------------
      ovfl=.false.
      do 151 i=1,neqn
         if(abs(yj(i,k)).gt.10.0d0*solmax)then
            ovfl=.true.
            goto 152
         endif
  151 continue
  152 if(ovfl)then
         badcn=.true.
         h=0.5d0*h
         chh=.true.
         reduh=.true.
         if(freshj)then
            goto 50
         else
            goto 40
         endif
      endif
      if(iter.ge.2)then
         if(wenorm(neqn,trsh,v(1,k),yj(1,k)).gt.1.0d0)then
            badcn=.true.
            h=0.5d0*h
            chh=.true.
            reduh=.true.
            if(freshj)then
               goto 50
            else 
               goto 40
            endif
         endif
      endif
      if(iter.lt.k-1)then
cvd$ concur
         do 155 l=1,k
            do 155 i=1,neqn
  155          yjm1(i,l)=yj(i,l)
         goto 95
      endif
      if(iter.eq.k-1)then
         enrml=wenorm(neqn,trsh,v(1,k),yj(1,k))
cvd$ concur
         do 157 l=1,k
            do 157 i=1,neqn
  157          yjm1(i,l)=yj(i,l)
         goto 95
      endif
      enrm=wenorm(neqn,trsh,v(1,k),yj(1,k))
      rate=enrm/enrml
c     write(6,888)t,iter,rate,enrm,h
  888 format('  iterate:',f12.4,i5,2e12.5,f12.4)
      if(iter.eq.itermx)then
         badcn=.true.
         h=0.5d0*h
         chh=.true.
         reduh=.true.
         if(freshj)then
            goto 50
         else
            goto 40
         endif
      else
         badcn=.false.
         if((rate .lt.1.0d0 .and. 
     +      rate/(1.0d0-rate)*enrm.lt.gamma*tol) .or.
     +      (enrm.lt.delta*tol) )goto 170
         if(rate.lt.1.0d0 .and.
     +      (rate**(itermx-iter))*enrm/(1.0d0-rate).gt.gamma*tol)then
c           write(6,876)t,iter
  876       format(' t=',f10.5,' iter=',i5,' too many iterations')
            badcn=.true.
            h=0.5d0*h
            chh=.true.
            reduh=.true.
            if(freshj)then
               goto 50
            else
               goto 40
            endif
         else
            enrml=enrm
cvd$ concur
            do 160 l=1,k
               do 160 i=1,neqn
  160             yjm1(i,l)=yj(i,l)
            goto 95
         endif
      endif
c----------------
c   error control
c----------------
  170 do 210 i=1,neqn
         aux(i)=bref(1)*y(i)+h*b0*dyn(i)-yj(i,k)
         do 200 l=1,k
  200       aux(i)=aux(i)+bref(l+1)*yj(i,l)
  210 continue
      if (banded) then
         call dgbsl(rjlu(1,1,k),np,neqn,mljac,mujac,ipvt(1,k),aux,0)
      else
         call dgesl(rjlu(1,1,k),np,neqn,ipvt(1,k),aux,0)
      endif
      nfb=nfb+1
      nfbs=nfbs+1
      error=wenorm(neqn,trsh,aux,yj(1,k))
      p=k+1
      fac=max(1.0d0/4.0d0,min(10.0d0,(error/tol)**(1.0d0/p)/0.9d0))
      hnew=h/fac
      if(error .gt. tol)then
c--------------------
c   step is rejected
c--------------------
         if(naccpt .ge. 1)nrejct=nrejct+1
         reject=.true.
         h=0.7d0*hnew
         chh=.true.
         goto 30
      else
c-------------------
c   step is accepted
c-------------------
         naccpt=naccpt+1
         t=t+h
c 	print *, t,h
         if(reject)then
            hnew=min(h,hnew)
            reject=.false.
         endif
         if (h.lt. 0.9d0*hlast) hnew=min(h,hnew)
         if(reduh)hnew=min(h,hnew)
         hlast=h
         if(hnew/h .gt. 1.20d0  .or.  hnew/h .lt. 0.95d0)then
            h=hnew
            chh=.true.
         else
            chh=.false.
         endif
         do 230 i=1,neqn
            y(i)=yj(i,k)
  230    continue
cvd$ concur
         do 220 l=1,k
            do 220 i=1,neqn
  220          yjl(i,l)=yj(i,l)
         if(iter.gt.10 .and. .not.freshj)badcn=.true.
c     write(6,9999)t,h,hnew,1.0/fac,error,nsteps,naccpt,nrejct,njac,
c    +             nlu,nfe
c9999 format(e12.5,2e10.3,f8.2,e10.2,i5,i5,i3,i4,i5,i6)
         goto 20
      endif
      end
      double precision function wenorm(neqn,trsh,v,vs)
      implicit double precision(a-h,o-z)
      dimension v(neqn),vs(neqn)
      wenorm=0.0d0
      do 10 i=1,neqn
         denom=max(1.0d-6,trsh,abs(vs(i)))
         wenorm=wenorm+(v(i)/denom)**2
   10 continue
      wenorm=sqrt(wenorm/neqn)
      return
      end
      subroutine colpol(neqn,np,yin,yout,c,l,k,q)
      implicit double precision(a-h,o-z)
      dimension yin(np,*),yout(np,*),c(4),fac(1:4)
      do 30 i=1,k
         fac(i)=1.0d0
         do 20 j=1,k
            if(j.ne.i)then
               fac(i)=fac(i)*(q-c(j))/(c(i)-c(j))
            endif
   20       continue
   30    continue
      do 50 i=1,neqn
         yout(i,l)=0.0d0
         do 40 j=1,k
   40       yout(i,l)=yout(i,l)+fac(j)*yin(i,j)
   50    continue
      return
      end
      subroutine correc(cor,nm,a,avec,c,k,d)
      implicit double precision(a-h,o-z)
      dimension a(nm,*),avec(nm),c(nm),d(nm)
      integer cor
      goto(10,20,30,40,50,60),cor
c---------------
c   lagrange k=2
c---------------
   10 k=2
      a(1,1)=216.0d0/288.0d0
      a(1,2)=-81.0d0/288.0d0
      a(2,1)=256.0d0/288.0d0
      a(2,2)=-48.0d0/288.0d0
      avec(1)=81.0d0/288.0d0
      avec(2)=80.0d0/288.0d0
      c(1)=0.75d0
      c(2)=1.0d0
      d(1)=0.75d0/(sqrt(2.0d0)+1.0d0)
      d(2)=1.0d0/(6.0d0*(sqrt(2.0d0)-1.0d0))
      return
c--------------------------
c   2-point radau IIa (k=2)
c--------------------------
   20 k=2
      a(1,1)=5.0d0/12.0d0
      a(1,2)=-1.0d0/12.0d0
      a(2,1)=0.75d0
      a(2,2)=0.25d0
      avec(1)=0.0d0
      avec(2)=0.0d0
      c(1)=1.0d0/3.0d0
      c(2)=1.0d0
      d(1)=(4.0d0-sqrt(6.0d0))/6.0d0
      d(2)=(4.0d0+sqrt(6.0d0))/10.0d0
      return
c---------------
c  lagrange, k=3
c---------------
   30 k=3
      a(1,1)=1757.0d0/2160.0d0
      a(1,2)=-5831.0d0/8640.0d0
      a(1,3)=4459.0d0/17280.0d0
      a(2,1)=25.0d0/27.0d0
      a(2,2)=-55.0d0/108.0d0
      a(2,3)=25.0d0/108.0d0
      a(3,1)=32.0d0/35.0d0
      a(3,2)=-2.0d0/5.0d0
      a(3,3)=3.0d0/10.0d0
      avec(1)=3227.0d0/17280.0d0
      avec(2)=5.0d0/27.0d0
      avec(3)=13.0d0/70.0d0
      c(1)=7.0d0/12.0d0
      c(2)=5.0d0/6.0d0
      c(3)=1.0d0
      d(1)=0.21051645d0
      d(2)=0.28849216d0
      d(3)=0.33912361d0
      return
c-------------------------------------------
c   3-point radau IIa (k=3)
c-------------------------------------------
   40 k=3
      s6=sqrt(6.0d0)
      a(1,1)=(88.0d0-7.0d0*s6)/360.0d0
      a(1,2)=(296.0d0-169.0d0*s6)/1800.0d0
      a(1,3)=(-2.0d0+3.0d0*s6)/225.0d0
      a(2,1)=(296.0d0+169.0d0*s6)/1800.0d0
      a(2,2)=(88.0d0+7.0d0*s6)/360.0d0
      a(2,3)=(-2.0d0-3.0d0*s6)/225.0d0
      a(3,1)=(16.0d0-s6)/36.0d0
      a(3,2)=(16.0d0+s6)/36.0d0
      a(3,3)=1.0d0/9.0d0
      avec(1)=0.0d0
      avec(2)=0.0d0
      avec(3)=0.0d0
      c(1)=a(1,1)+a(1,2)+a(1,3)
      c(2)=a(2,1)+a(2,2)+a(2,3)
      c(3)=1.0d0
      d(1)=0.32039049d0
      d(2)=0.13997017d0
      d(3)=0.37167618d0
      return
c-------------------------------------------
c  lagrange, k=4
c-------------------------------------------
   50 k=4
      a(1,1)=2213.0d0/20250.0d0
      a(1,2)=-551.0d0/31500.0d0
      a(1,3)=331.0d0/17820.0d0
      a(1,4)=-301.0d0/27000.0d0
      a(2,1)=113533.0d0/324000.0d0
      a(2,2)=19187.0d0/72000.0d0
      a(2,3)=-35329.0d0/285120.0d0
      a(2,4)=3773.0d0/54000.0d0
      a(3,1)=105149.0d0/324000.0d0
      a(3,2)=222277.0d0/504000.0d0
      a(3,3)=3773.0d0/25920.0d0
      a(3,4)=-1331.0d0/54000.0d0
      a(4,1)=122.0d0/375.0d0
      a(4,2)=384.0d0/875.0d0
      a(4,3)=32.0d0/165.0d0
      a(4,4)=3.0d0/250.0d0
      avec(1)=5609.0d0/83160.0d0
      avec(2)=973.0d0/47520.0d0
      avec(3)=913.0d0/30240.0d0
      avec(4)=23.0d0/770.0d0
      c(1)=1.0d0/6.0d0
      c(2)=7.0d0/12.0d0
      c(3)=11.0d0/12.0d0
      c(4)=1.0d0
      d(1)=0.13380299d0
      d(2)=0.11358038d0
      d(3)=0.22689850d0
      d(4)=0.25010131d0
      return
c-------------------------------------------
c  four-point radau IIa ,k=4
c-------------------------------------------
   60 k=4
      a(1,1)=0.11299947932316d0
      a(1,2)=-.04030922072352d0
      a(1,3)=0.02580237742034d0
      a(1,4)=-.00990467650730d0
      a(2,1)=0.23438399574740d0
      a(2,2)=0.20689257393536d0
      a(2,3)=-.04785712804854d0
      a(2,4)=0.01604742280652d0
      a(3,1)=0.21668178462325d0
      a(3,2)=0.40612326386737d0
      a(3,3)=0.18903651817006d0
      a(3,4)=-.02418210489983d0
      a(4,1)=0.22046221117677d0
      a(4,2)=0.38819346884317d0
      a(4,3)=0.32884431998006d0
      a(4,4)=1.0d0/16.0d0
      avec(1)=0.0d0
      avec(2)=0.0d0
      avec(3)=0.0d0
      avec(4)=0.0d0
      c(1)=a(1,1)+a(1,2)+a(1,3)+a(1,4)
      c(2)=a(2,1)+a(2,2)+a(2,3)+a(2,4)
      c(3)=a(3,1)+a(3,2)+a(3,3)+a(3,4)
      c(4)=1.0d0
      d(1)=0.32049937d0
      d(2)=0.08915379d0
      d(3)=0.18173957d0
      d(4)=0.23336280d0
      return
      end
